/***************************************************************************
 *   Copyright (C) 2007 by Antony Martin                                   *
 *   martin.antony@yahoo.fr                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

/* Cree le : 10 janvier 2007
   derniere modification le 10/02/2007 */

#ifndef __SCECMATRIX_H__
#define __SCECMATRIX_H__


/* constante symbolique representant la matrice active */
#define SCE_CURRENT_MATRIX 0


/* empile la matrice specifiee en argument
(0 pour specifier la matrice active) */
void SCE_CPushMatrix(const GLenum);

/* libere la matrice specifiee en argument
(0 pour specifier la matrice active) */
void SCE_CPopMatrix(const GLenum);

/* empile et selectionne la matrice specifiee en argument
(0 pour specifier la matrice active) */
void SCE_CPushSetMatrix(const GLenum);

/* libere et selectionne la matrice specifiee en argument
(0 pour specifier la matrice active) */
void SCE_CPopSetMatrix(const GLenum);

/* selectionne la matrice specifiee en argument comme matrice active */
void SCE_CSetMatrixMode(const GLenum);

/* renvoie le mode de la matrice active */
GLint SCE_CGetMatrixMode(void);

/* multiplie la matrice specifiee */
void SCE_CMultMatrix(const GLenum, const float*);

/* change la matrice specifiee */
void SCE_CLoadMatrix(const GLenum, const float*);

/* selectionne la matrice specifiee et la multiplie */
void SCE_CMultSetMatrix(const GLenum, const float*);

/* selectionne la matrice specifiee et la change */
void SCE_CLoadSetMatrix(const GLenum, const float*);

/* retourne la matrice demandee */
void SCE_CGetMatrix(int, float*);



/* multiplication de la matrice active par une matrice de translation */
void SCE_CMatrixTranslate(float, float, float);

/* multiplication de la matrice active par une matrice de rotation */
void SCE_CMatrixRotate(float, float, float, float);

/* multiplication de la matrice active par une matrice de remise a l'echelle */
void SCE_CMatrixScale(float, float, float);

/* version vectorielles */
void SCE_CMatrixTranslatev(float*);
void SCE_CMatrixRotatev(float, float*);
void SCE_CMatrixScalev(float*);
/***/


/* definit un point de vue */
void SCE_CLook(
  float, float, float,
  float, float, float,
  float, float, float);

/* version vectorielle */
void SCE_CLookv(const float*, const float*, const float*);


/* cree une matrice de projection en perspective */
void SCE_CSetPerspectiveMatrix(GLdouble, GLdouble, GLdouble, GLdouble);

/* cree une matrice de frustum de vision en perspective */
void SCE_CSetMatrixFrustum(
  GLdouble, GLdouble,
  GLdouble, GLdouble,
  GLdouble, GLdouble);

/* cree une matrice de projection en perspective cavaliere */
void SCE_CSetOrthoMatrix(
  GLdouble, GLdouble,
  GLdouble, GLdouble,
  GLdouble, GLdouble);


/* definit le cadrage actif dans lequel dessiner */
void SCE_CViewport(int,int,int,int);


#endif /* guard */
