/* Cree le : 16 mars 2007
 */

/* 
 * structures par David Henry
 * fichier par Antony Martin
 * cree le 03/03/07 pour le SCEngine afin de tester son
 * gestionnaire de textures et le format compresse DXT
 */



#ifndef __SCEDDSLOADER_H__
#define __SCEDDSLOADER_H__


/* OpenGL texture info */
typedef struct
{
    GLsizei width;
    GLsizei height;
    
    GLenum format;
    
    GLubyte *texels;
    
    GLint n_levels;
    
} SCE_SDDSImage;


/* DirectDraw's structures */
typedef struct
{
    GLuint size;
    GLuint flags;
    GLuint fourCC;
    GLuint bpp;
    GLuint redMask;
    GLuint greenMask;
    GLuint blueMask;
    GLuint alphaMask;
    
} SCE_SDDPixelFormat;


typedef struct
{
    GLuint caps;
    GLuint caps2;
    GLuint caps3;
    GLuint caps4;
    
} SCE_SDDSCaps;


typedef struct
{
    GLuint lowVal;
    GLuint highVal;
    
} SCE_SDDColorKey;


typedef struct
{
    GLuint size;
    GLuint flags;
    GLuint height;
    GLuint width;
    GLuint pitch;
    GLuint depth;
    GLuint n_levels;
    GLuint alphaBitDepth;
    GLuint reserved;
    GLuint surface;
    
    SCE_SDDColorKey ckDestOverlay;
    SCE_SDDColorKey ckDestBlt;
    SCE_SDDColorKey ckSrcOverlay;
    SCE_SDDColorKey ckSrcBlt;
    
    SCE_SDDPixelFormat format;
    SCE_SDDSCaps caps;
    
    GLuint textureStage;
    
} SCE_SDDSurfaceDesc;


/* fonction de chargement d'un fichier au format .dds (compresse) */
void* SCE_DDS_LoadFromFile(FILE*, const char*);

#endif /* guard */
