/***************************************************************************
 *   Copyright (C) 2007 by Antony Martin                                   *
 *   martin.antony@yahoo.fr                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

/* Cree le : 3 novembre 2006
   derniere modification le 23/02/2007 */


#ifndef __SCEM3DLOADER_H__
#define __SCEM3DLOADER_H__

#define SCE_M3D_MAGIC (0x000200bb)

typedef struct mat SCE_M3D_Mat;
struct mat
{
    float ambient[4];
    float diffuse[4];
    float specular[4];
    float shininess;
};



typedef struct obj3d SCE_M3D_Model;
struct obj3d
{
    unsigned int vsize;
    unsigned int nsize;
    unsigned int tsize;
    
    GLenum type;
    size_t size;
    
    float *vertices;
    float *texcoords;
    float *normals;
    
    unsigned int lines_count;
    unsigned int triangles_count;
    unsigned int quads_count;
    
    /* les indices sont de type void,
       plus de flexibilité au niveau du type des indices : short ou int */
    void *lines_index;
    void *triangles_index;
    void *quads_index;
    
    SCE_M3D_Mat *material;
};



void* SCE_M3D_Load(FILE*, const char*, void*);

#if 0
int SCE_M3D_MakeObj(M3D_Obj*, const int);
#endif

int SCE_M3D_Free(void*, void*);

/*
void M3D_PrintObjs(const M3D_Obj*, const unsigned int);*/


#endif /* guard */
