/***************************************************************************
 *   Copyright (C) 2007 by Antony Martin                                   *
 *   martin.antony@yahoo.fr                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

/* Cree le : 2 janvier 2007
   derniere modification le 15/01/2007 */


/*
    ResourceManager
    Interface, couche 2
*/

#ifndef __SCERESOURCES_H__
#define __SCERESOURCES_H__



typedef struct sce_sresource_info SCE_SResourceInfo;
struct sce_sresource_info
{
    /* identifiant du type de la ressource */
    int type_id;
    
    /* nom */
    char *name;
    
    /* nombre d'objets qui utilisent la ressource */
    unsigned int n_utils;
    
    /* objets qui l'utilisent... ? */
    /*void *obj;*/
};


typedef struct sce_sresource SCE_SResource;
struct sce_sresource
{
    void *media;
    SCE_SResourceInfo *info;
};


/* quelques types predefinis du moteur */ /* NOTE: a deplacer... re-NOTE: a virer.. ? */
/* texture */
typedef struct sce_sresourcetexture SCE_STexture;
struct sce_sresourcetexture
{
    int w, h, d;
    
    GLint internalFormat;
    GLint border;
    
    GLenum target;
    GLenum format;
    GLenum type;
    
    void *texels;
};

/* model simple */
typedef struct sce_sresourcemodel SCE_SModel;
struct sce_sresourcemodel
{
    unsigned int vsize;
    unsigned int nsize;
    unsigned int tsize;
    
    GLenum type;
    size_t size;
    
    float *vertices;
    float *texcoords;
    float *normals;
    
    unsigned int lines_count;
    unsigned int triangles_count;
    unsigned int quads_count;
    
    /* les indices sont de type void,
    plus de flexibilité au niveau du type des indices : short ou int */
    void *lines_index;
    void *triangles_index;
    void *quads_index;
};
/***/


int SCE_ResourceManager_Init(void);

SCE_SResource* SCE_ResourceManager_Load(const char*, void*);


#endif /* guard */
