/***************************************************************************
 *   Copyright (C) 2007 by Antony Martin                                   *
 *   martin.antony@yahoo.fr                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

/* Cree le : 21 decembre 2006
   derniere modification le 08/03/2007 */


#include <SCE/utils/SCEMath.h>

#include <SCE/utils/SCEVector.h>


void SCE_Vector3_Normalize(SCE_TVector3 v)
{
    float r = SCE_Math_InvSqrt((v[0]*v[0])+(v[1]*v[1])+(v[2]*v[2]));
    SCE_Vector3_Operator1(v, *=, r);
}

void SCE_Vector2_Normalize(SCE_TVector2 v)
{
    float r = SCE_Math_InvSqrt((v[0]*v[0])+(v[1]*v[1]));
    SCE_Vector2_Operator1(v, *=, r);
}



void SCE_Vector3_RotateX(SCE_TVector3 v, float cos_, float sin_)
{
    SCE_TVector3 vec;
    
    vec[1] = v[1];
    vec[2] = v[2];
    
    v[1] = (vec[1] * cos_) - (vec[2] * sin_);
    v[2] = (vec[1] * sin_) + (vec[2] * cos_);
}


void SCE_Vector3_RotateY(SCE_TVector3 v, float cos_, float sin_)
{
    SCE_TVector3 vec;
    
    vec[0] = v[0];
    vec[2] = v[2];
    
    v[0] = (vec[0] * cos_) + (vec[2] * sin_);
    v[2] = (vec[2] * cos_) - (vec[0] * sin_);
}


void SCE_Vector3_RotateZ(SCE_TVector3 v, float cos_, float sin_)
{
    SCE_TVector3 vec;
    
    vec[0] = v[0];
    vec[1] = v[1];
    
    v[0] = (vec[0] * cos_) - (vec[1] * sin_);
    v[1] = (vec[0] * sin_) + (vec[1] * cos_);
}
